#ifndef CONF_H__
#define CONF_H__

/*

	CONFIGURATION FILE LIBRARY

	$Id: conf.h,v 1.1 2007/01/17 12:50:01 cihan Exp $

	Copyright (c) 2004, Murat Balaban
	All rights reserved.

	Redistribution and use in source and binary forms, with or without 
	modification, are permitted provided that the following conditions 
	are met:

	Redistributions of source code must retain the above copyright notice, 
	this list of conditions and the following disclaimer. 
	Redistributions in binary form must reproduce the above copyright notice, 
	this list of conditions and the following disclaimer in the documentation 
	and/or other materials provided with the distribution. 
	Neither the name of the Murat Balaban nor the names of its contributors may 
	be used to endorse or promote products derived from this software without 
	specific prior written permission. 
	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
	GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
	HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
	OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
	DAMAGE.
*/


#define	CONFERRBUFSIZ	1024
#define	CONFFILESIZ	256

#define  SECTSIZ  256
#define  KEYWORDSIZ  256
#define  VALSIZ   1024


typedef struct confsect confsect;
typedef struct confnode confnode;
typedef struct config config;

struct confnode {
	char node[KEYWORDSIZ];
	char val[VALSIZ];
	struct confnode *next;
};

struct confsect {
	char sect[SECTSIZ];
	struct confnode *nodes;
	struct confsect *next;
};

struct config {
	char file[CONFFILESIZ];
	struct confsect *sects;
};

int
config_getsectionname(char *sect, int len, char *buf);

int
config_getkwvalpair(char *kw, int kwlen, char *val, int vallen, char *buf);

config *
config_parse(config *cfg, FILE *fp, char *errbuf);

config *
config_load(config *cfg, const char *path, char *errbuf);

void
config_dump(const config *cfg);

void
config_free(config *cfg);

const char *
config_getval(config *cfg, char *st, char *kw);

int 
config_getstr(config *cfg, char *st, char *kw, char *out, int outlen);

int 
config_getint(config *cfg, char *st, char *kw, int defval);

long 
config_getlong(config *cfg, char *st, char *kw, long defval);

double 
config_getdouble(config *cfg, char *st, char *kw, double defval);

int
config_save(const config *cfg, char *errbuf);


#endif
