#include <stdio.h>
#define __USE_BSD 1
#define __FAVOR_BSD 1
#include <sys/types.h>

#include "hash.h"
#include "defs.h"
extern int NumberOfAccount;
extern struct account_ip *accounts[MEMORYSIZE];

void hashing(struct account_ip *user)
{
	struct account_ip *list_user;
	unsigned int h;

	h = produce_key(user->srcip, user->dstip, user->srcport, user->dstport);
	
	list_user = accounts[h];
	accounts[h] = (struct account_ip*) malloc(sizeof(struct account_ip));

	if(list_user == NULL) 
		accounts[h]->next = NULL;
	 else
		accounts[h]->next = list_user;
		
	
	adduser(h, accounts[h] , user);
} 

unsigned int produce_key( u_int32_t sip, u_int32_t dip, u_int16_t sp, u_int16_t dp )
{
	
	unsigned int key;

	key = (unsigned int)(sip * dip * sp * dp);
	key += ~(key << 15);
	key ^=  (key >> 10);
	key +=  (key << 3);
	key ^=  (key >> 6);
	key += ~(key << 11);
	key ^=  (key >> 16);
	
	return key % MEMORYSIZE;
}

struct account_ip *lineer_search(struct account_ip *user, int control)
{	
	unsigned int h =  produce_key(user->srcip, user->dstip, user->srcport, user->dstport);
	struct account_ip *list_user, *temp;
	
	

	list_user = accounts[h];
	
	temp = list_user;
	while (list_user != NULL){  

			if((list_user->dstip == user->dstip)&& (list_user->srcip == user->srcip) && (list_user->srcport == user->srcport) && (list_user->dstport == user->dstport))
				break;
			temp = list_user;
			list_user = list_user->next;
			
		}
	if(control == 1){
		return list_user;		
	}else if(control == 2 && list_user != NULL ){

		
		if(list_user->next == NULL && accounts[h] == list_user)
			accounts[h] = NULL;
		else if(list_user->next == NULL)
			temp->next = NULL;
		else if(accounts[h] == list_user){
			temp = list_user->next;
			accounts[h] = temp;
		}else
			temp->next = list_user->next;
			
		
		free(list_user);

			
	}else
		return NULL;
	
	

}



void adduser(unsigned int h, struct account_ip *list_user, struct account_ip *user)
{
	list_user->srcip = user->srcip;
	list_user->dstip = user->dstip;
	list_user->dstport = user->dstport;
	list_user->srcport = user->srcport;


	strncpy(list_user->account , user->account, sizeof(user->account));
	list_user->account[sizeof(user->account ) - 1] = '\0';	
	
	
}

