#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include <config.h>

#include <pcap.h>
#include "defs.h"

#ifdef _mysql_
#include "db.h"

#endif
#include "main.h"

pcap_t *handle;
pcap_if_t *alldev;
char pathdb[128];
extern char *optarg;
extern int optopt;

int main(int argc, char **argv){
	pcap_if_t  *first;
	char errbuf[PCAP_ERRBUF_SIZE];
	int a, c,b;
	char *device,*pth;

	
	if (getuid() != 0){
		printf("You must Root\n");
		exit(EXIT_FAILURE);
	
	}
	
	if(argc == 1){
		printf("Syntax Error:\n");
		printf("For more information \"scanhill -h\" \n");
		exit(EXIT_FAILURE);
	
	}
	if(pcap_findalldevs(&alldev, errbuf) == -1){
		fprintf(stderr, "findalldevs : %s\n", errbuf);
		exit(EXIT_FAILURE);
	}
	
	
	strcpy(pathdb, "/etc/scanhill.conf");
	if((c = getopt(argc,argv,"c:i:lh")) != -1)
	 	do{
		switch(c){
			case 'l' :
				  a = 1;
				  printf("interface no  \tinterface\n");
				  while(alldev != NULL){
					printf("\t%d \t\t %s\n", a, alldev->name);
					alldev = alldev->next;
					a++;

				  }
				  exit(1);
			case 'i' :
				  device = optarg;
				  for(a = 0;  alldev != NULL; a++ )
				   	if(strcmp(device,alldev->name) == 0)
						break;
					else
						alldev = alldev->next;
			
					if(alldev == NULL){
						fprintf(stderr, "Wrong interface name.Please use help");
						exit(0);
					}			
					handle = pcap_open_live(alldev->name, SNAP_LEN, 1, 1000, errbuf);
					if(handle == NULL){
						fprintf(stderr,"Couldn't open device %s:%s\n", alldev->name, errbuf);
						exit(EXIT_FAILURE);
					}
					
				  break;
			
			case 'c' :
				b = 0;
				for(a = 1; a < argc; a++)
					if(strcmp(argv[a], "-i") == 0)
						b = 1;
				if (b != 1){
					printf("Syntax Error\n For help: scanhill -h\n");
				 	exit(1);
				}
				pth = optarg;
				if(strlen(pth) > 127){
					printf("Config file path is too long");
				        exit(0);
				}else
					strcpy(pathdb, pth);
						
				break;
			case 'h' :
				  printf("1.) List interface\n\t %-30s \n2.) for sniff msn \n\t%-30s\n3.)Specify another config file (default:/etc/scanhill.conf) \n\t%-30s\n4.) help\n\t%-30s\n","scanhill -l", "scanhill -i [interface name]","scanhill -i [interface name] -c [config file path]", "scanhill -h");
				  exit(1);
			
			default  :
				  printf("Syntax Error\n For help: scanhill -h\n");
				  exit(1);

		}
		}while((c = getopt(argc,argv,"c:i:lh")) != -1 );
	else{
		 printf("Syntax Error\n For help: scanhill -h\n");
		 exit(1);
	}
		
	
	#ifdef _mysql_
	db_initialize();
	#endif
	sniffing();
}
